class Bomb {
  int x, y;
  int fuse;
  boolean active;
  boolean exploding;
  
  Bomb(int x, int y) {
    this.x = x;
    this.y = y;
    fuse = 120;
    active = true;
    exploding = false;
  }
  
  void Draw() {
    if (!exploding) {
      if ((fuse / 8) % 2 == 0) {
        DrawPixel(x, y, 255, 255, 255);
      }
    }
    else {
      float progress = (float) fuse / 15.0f;
      for (int i = 0; i < 16; i ++) {
        DrawPixel(
          x + (int) (progress * blastRadius - progress * random(2 * blastRadius)), 
          y + (int) (progress * blastRadius - progress * random(2 * blastRadius)), 
          255, 255, 255);
      }
    }
  }
  
  void Update() {
    if (!exploding) {
      fuse --;
      if (fuse <= 0) {
        exploding = true; 
      }
    }
    else {
      // Check monsters
      int dX = x - playerX;
      int dY = y - playerY;
      float progress = (float) fuse / 15.0f;
      if ((abs(dX) < progress * blastRadius)
      && (abs(dY) < progress * blastRadius)) {
        dead = true;
      }
     for (int i = 0; i < monster.length; i ++) {
        if (monster[i] != null) {
          dX = monster[i].x - x;
          dY = monster[i].y - y;
          if ((abs(dX) < blastRadius)
          && (abs(dY) < blastRadius)) {
            monster[i].active = false;
          }
        }
      }
      MakeRoom(
        (int) (x - progress * blastRadius + 1), 
        (int) (y - progress * blastRadius + 1), 
        (int) (progress * 2 * blastRadius - 1), 
        (int) (progress * 2 * blastRadius - 1));
      fuse ++;
      if (fuse >= 15) {
        active = false;
      }
    }
  }
}
